{{

Spin code by Clock Loop.   Client.
The code communicates with the wx module and a propeller that is connects to another prop via its wx module.

}}

CON 

  _CLKMODE  = XTAL1 + PLL16X                              ' The system clock spec
  _XINFREQ  = 5_000_000                                  ' Crystal

  Rx        = 31    'serial in from wx device
  Tx        = 30    'serial out to wx device
                  
OBJ

    ser:    "Parallax Serial Terminal.spin"

VAR 

    byte  Handle, ReplyStatus, ClientListener
    long  Comm[100] 

Pub Main      'Cog #1
 
  cognew(Comms, @Comm)   'Cog #2 and #3
  
  waitcnt(80_000_000 + cnt) 'Wait for 1 s
                               
  Counter   'Start counter loop. Cog #1
                                                         
PUB Counter     'Cog #1
  Repeat   
    waitcnt(80_000_000 + cnt)   'Wait for 1 s                                             

Pub Comms     'Cog #2 and #3

   
  dira[TX]~~          ' Set direction to output
  outa[TX]:= 0        ' Set TX low.                         
  waitcnt(5_000_000 + cnt)   'wait 1/16 second for command mode to start in the module.
  dira[TX]~           ' Set direction to input  
  
  ser.StartRxTx(RX, TX, 0, 115200)   'Cog #3  Parallax Serial Terminal does NOT work at receiving data 230400 for some reason.
  waitcnt(5_000_000 + cnt)   'wait 1/16 second for serial to start.                        
 
  ser.str(string(27))     'Set ansi command mode in putty.
  ser.str(string("[2J"))  'Clear putty telnet screen. 
 
  ser.str(string(27))      'Set ansi command mode in putty.                 
  ser.str(string("[2;3f")) 'Set Position in putty.      
  ser.str(string("Prop Communication Started.")) 'Tell putty command mode is on.                       
  ser.str(string(27))      'Set ansi command mode in putty.      
  ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0        
  Repeat 5  ' wait 5 seconds to help determine if prop reset.
    waitcnt(80_000_000 + cnt)   'wait 1 second 
  
Repeat                'The main repeat loop.  Cog#2
  
  If ClientListener <> 0
    
    'Repeat 5  ' wait 20 seconds to look at last data.  You can change the values for Xaxis and Yaxis in the host DAT section.
      
      'waitcnt(80_000_000 + cnt)   'wait 1 second  
  
    ser.str(string(27))     'Set ansi command mode in putty.
    ser.str(string("[2J"))  'Clear putty telnet screen. 
    
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[5;1f")) 'Set Position in putty   
    ser.str(string("Xaxis- ")) 'Tell putty error.
    ser.dec(Xaxis)
    
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[6;1f")) 'Set Position in putty   
    ser.str(string("Yaxis- ")) 'Tell putty error.
    ser.dec(Yaxis)

    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[1:1f")) 'Set Position in putty
    
    Reply[0] := 0  ' clear data
    Reply[1] := 0  ' clear data
    Reply[2] := 0  ' clear data
    Reply[3] := 0  ' clear data
    Reply[4] := 0  ' clear data
    Reply[5] := 0  ' clear data
    Reply[6] := 0  ' clear data
    Reply[7] := 0  ' clear data
    
    ser.rxflush                     
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(254)               'Begin marker
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.str(string("CLOSE:"))    'Tell the module to connect to a specific address.
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(ClientListener)    'An active connection handle; returned by POLL   
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(13)                'End marker     
    'Repeat 3                    'Let buffer fill.  The connect command's timeout is almost 10 seconds. So you MUST wait.
      waitcnt(1_000_000 + cnt) 'Wait for 1 s      
    Reply[0] := ser.rxcheck     ' should be 254
    Reply[1] := ser.rxcheck     ' should be =
    Reply[2] := ser.rxcheck     ' should be S
    Reply[3] := ser.rxcheck     ' should be ,
    Reply[4] := ser.rxcheck     ' should be 0 if success. this could change. Use the returned connection handle with PATH, CLOSE, SEND, or RECV commands.
                                ' There are a maximum of four connections available; shared between successfulCONNECT requests and active listener connections.
                                ' Issuing additional CONNECT commands when all four connections are already established will result in a
                                ' response of b = E,5 E (NO_FREE_CONNECTION) until a CLOSE command is used to free a connection.
    Reply[5] := ser.rxcheck     ' should be 13  
    
    If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "S" And Reply[3] == "," And Reply[4] == "0" And Reply[5] == 13 

      ClientListener := 0  
    Else
      Repeat
        waitcnt(80_000_000 + cnt) 'Wait for 1s forever.
        ser.str(string(27))      'Set ansi command mode in putty.                 
        ser.str(string("[15;3f")) 'Set Position in putty.      
        ser.str(string("ERROR, wrong connect clse message returned.")) 'Tell putty error.                       
        ser.str(string(27))      'Set ansi command mode in putty.      
        ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0  
    
  Reply[0] := 0  ' clear data
  Reply[1] := 0  ' clear data
  Reply[2] := 0  ' clear data
  Reply[3] := 0  ' clear data
  Reply[4] := 0  ' clear data
  Reply[5] := 0  ' clear data
  Reply[6] := 0  ' clear data
  Reply[7] := 0  ' clear data
  
  ser.rxflush                     
  waitcnt(1_000_000 + cnt)    'wait 1/16 second.
  ser.char(254)               'Begin marker
  waitcnt(1_000_000 + cnt)    'wait 1/16 second.
  ser.str(string("CONNECT:caboose.railroad.local,80"))    'Tell the module to connect to a specific address.
  waitcnt(1_000_000 + cnt)    'wait 1/16 second.
  ser.char(13)                'End marker     
  'Repeat 3                    ' The connect command's timeout is almost 10 seconds. So you MUST wait.
    waitcnt(10_000_000 + cnt) ' Wait for 1 s  'Even a successful connect command times almost 10 seconds to get a reply.
  Reply[0] := ser.rxcheck     ' should be 254
  Reply[1] := ser.rxcheck     ' should be =
  Reply[2] := ser.rxcheck     ' should be S
  Reply[3] := ser.rxcheck     ' should be ,
  Reply[4] := ser.rxcheck     ' should be 5, 6 this could change. Use the returned connection handle with PATH, CLOSE, SEND, or RECV commands.
                              ' There are a maximum of four connections available; shared between successfulCONNECT requests and active listener connections.
                              ' Issuing additional CONNECT commands when all four connections are already established will result in a
                              ' response of b = E,5 E (NO_FREE_CONNECTION) until a CLOSE command is used to free a connection.
  Reply[5] := ser.rxcheck     ' should be 13  
  
    If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "S" And Reply[3] == "," And Reply[5] == 13 
      
      ClientListener := Reply[4]   
    Else
      'Repeat
        waitcnt(80_000_000 + cnt) 'Wait for 1s forever.
        ser.str(string(27))      'Set ansi command mode in putty.                 
        ser.str(string("[15;3f")) 'Set Position in putty.      
        ser.str(string("ERROR, wrong cnnet listener returned. Power cycle the esp and prop.")) 'Tell putty error.                       
        ser.str(string(27))      'Set ansi command mode in putty.      
        ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0 
                                  
    
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[3;1f")) 'Set Position in putty  

    ser.str(string("Connection Good.")) 'Tell putty command mode is on.                       

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[1;1f")) 'Set Position in putty
  
    Reply[0] := 0  ' clear data
    Reply[1] := 0  ' clear data
    Reply[2] := 0  ' clear data
    Reply[3] := 0  ' clear data
    Reply[4] := 0  ' clear data
    Reply[5] := 0  ' clear data
   
    ser.rxflush                     
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(254)               'Begin marker
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.str(string("SEND:"))    'Retrieve the path associated with a connection handle or listener id.
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(ClientListener)    'An active connection handle; returned by POLL                            
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.str(string(","))      'Tell the module how many bytes? (or is this digits?) the send is.
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.str(string("92"))      'Tell the module how many bytes? (or is this digits?) the send is.
    'ser.str(string("87"))      'Tell the module how many bytes? (or is this digits?) the send is.
    waitcnt(1_000_000 + cnt)    'wait 1/16 second.
    ser.char(13)                'End marker     
    waitcnt(1_000_000 + cnt)    'Wait for 1/16 s  Let buffer fill.    
    ser.str(string("GET /hostess HTTP/1.1"))     '21    21   Twinkies.  
    ser.char(13)                '\r                1    22
    ser.char(10)                '\n                1    23  
    ser.str(string("Host: caboose.railroad.local")) '28    51  Change this to match your hostname.domain.local   you will need to count the total bytes with the new address.  Above
    ser.char(13)                '\r                1    52
    ser.char(10)                '\n                1    53  
    ser.str(string("Connection: keep-alive"))    '22    75
    ser.char(13)                '\r                1    76
    ser.char(10)                '\n                1    77
    ser.str(string("Accept: */*"))               '11    88                
    ser.char(13)                '\r                1    89
    ser.char(10)                '\n                1    90
    ser.char(13)                '\r                1    91
    ser.char(10)                '\n                1    92
    
    Repeat 10
        
        'waitcnt(20_000_000 + cnt) 'Wait for 1s

        Reply[0] := 0  ' clear data
        Reply[1] := 0  ' clear data
        Reply[2] := 0  ' clear data
        Reply[3] := 0  ' clear data
        Reply[4] := 0  ' clear data
        Reply[5] := 0  ' clear data
        Reply[6] := 0  ' clear data
        Reply[7] := 0  ' clear data
        Reply[8] := 0  ' clear data
        Reply[9] := 0  ' clear data
    
        ser.rxflush
        waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  
        ser.char(254)  'Begin marker
        waitcnt(1_000_000 + cnt) 'Wait for 1/16 s 
        ser.str(string("POLL:"))   'Tell the module to listen to a ANY protocol/path.
        waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  
        ser.char(13)    'End marker
        waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
        Reply[0] := ser.rxcheck   ' should be 254
        Reply[1] := ser.rxcheck   ' should be =
        Reply[2] := ser.rxcheck   ' should be D
        Reply[3] := ser.rxcheck   ' should be ,
        Reply[4] := ser.rxcheck   ' should be 5 (this could change) The connection identifier to use for this request
        Reply[5] := ser.rxcheck   ' should be ,
        Reply[6] := ser.rxcheck   ' should be The number of bytes of data received.
        Reply[7] := ser.rxcheck   ' should be number of bytes being sent, could be the end marker.                           ' 
        

        If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "D" And Reply[4] == "5"' And Reply[9] == 13
        
            If Reply[7] <> 13               'Not the end marker
              Reply[8] := ser.rxcheck       'should be number of bytes being sent, could be the end marker.     
              If Reply[8] <> 13             'Not the end marker
                Reply[9] := ser.rxcheck   'should be number of bytes being sent, could be the end marker.  
                If Reply[9] == 13         'The end marker all other conditions the end marker is a byte 7
                  Reply[9] := 0           'Zero terminate the string so it can be converted to decimal.
             
              Else
                Reply[8] := 0         'Zero terminate the string so it can be converted to decimal.
            Else
              Reply[7] := 0           'Zero terminate the string so it can be converted to decimal.               
        
            ReplyStatus := 1       'Set the reply to good so it can be shown in putty.
                     
            Handle := Reply[4]     'Store connection identifier.
           
            DataCount1 := ser.StrToBase(@long[@Reply[6]], 10)  ' store and convert string speed in byte variable speed.  
            
            Reply[0] := 0  ' clear data
            Reply[1] := 0  ' clear data
            Reply[2] := 0  ' clear data
            Reply[3] := 0  ' clear data
            Reply[4] := 0  ' clear data
            Reply[5] := 0  ' clear data
            Reply[6] := 0  ' clear data
            Reply[7] := 0  ' clear data
                       '   
            ser.rxflush             
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.char(254)               'Begin marker
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.str(string("RECV:"))    'Retrieve HTTP GET/POSTâ€™s name argument (in query or body) on connection handle.
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.char(Handle)            'An active connection handle; returned by POLL
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.str(string(","))        'Required for a reply
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.dec(DataCount1)          'The desired length of data to recieve.                         
            waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
            ser.char(13)                'End marker                                        
            'Repeat 2
              waitcnt(1_000_000 + cnt) 'Wait for 1 s  Let buffer fill.                        
                   
            Reply[0] := ser.rxcheck   ' should be 254
            Reply[1] := ser.rxcheck   ' should be =
            Reply[2] := ser.rxcheck   ' should be S
            Reply[3] := ser.rxcheck   ' should be ,
            Reply[4] := ser.rxcheck   ' should be number of bytes being sent.            
            Reply[5] := ser.rxcheck   ' should be number of bytes being sent, could be the end marker.
            
            If Reply[5] <> 13         'Not the end marker
              Reply[6] := ser.rxcheck ' should be number of bytes being sent, could be the end marker.     
              If Reply[6] <> 13       'Not the end marker
                If Reply[7] == 13     'The end marker all other conditions the end marker is a byte 7
                  Reply[7] := 0       'Zero terminate the string so it can be converted to decimal.
             
              Else
                Reply[6] := 0         'Zero terminate the string so it can be converted to decimal.
            Else
              Reply[5] := 0           'Zero terminate the string so it can be converted to decimal. 
            
            DataCount2 := ser.StrToBase(@long[@Reply[4]], 10)  ' store and convert string speed in byte variable speed.  


            If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "S" And Reply[3] == ","
                            
              ReplyStatus := 1       'Set the reply to good so it can be shown in putty.                                                                             
            
            
              If DataCount1 == DataCount2
                bytenumber := 0
                Repeat Datacount1
                  Data1[bytenumber] := ser.CharIn        
                  bytenumber++
                
                ser.str(string(27))      'Set ansi command mode in putty.      
                ser.str(string("[4;1f")) 'Set Position in putty                 
                ser.str(string("Good Verify. ")) 'Tell putty. 
                Xaxis := 0
                Yaxis := 0
                
                bytenumber := 84
                Repeat DataCount1 - 84
                
                  'ser.char(Data1[bytenumber])         
                  
                  If Data1[bytenumber - 6] == "X"
                    If Data1[bytenumber - 1] == ">"                       
                      Xaxis := ser.StrToBase(@byte[@Data1][93], 10)                        
                      
                      Yaxis := ser.StrToBase(@byte[@Data1][106], 10)
                      
                      ReplyStatus := 1
                      
                  bytenumber++
                
                Xchange2 := Xchange1 - Xaxis 
                Xchange1 := Xaxis
                
                Xchange2 := Xchange1 - Xaxis 
                Xchange1 := Xaxis               
  

DAT

  Xchange1          long  0
  Xchange2          long  0
  
  Ychange1          long  0
  Ychange2          long  0
  
  Xaxis             long  0, 0
  Yaxis             long  0, 0
  
  ClientCounter     long  0
  PollCounter       long  0
  
  'Byte[#]               '0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 18 20
  Reply             byte  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0

  Datacount1        long  0, 0
  Datacount2        long  0, 0
  
  Bytenumber        long  0
                      
  Data1             byte  " "[50]  'If the data sent is huge this could overload ram.
  Data2             byte  " "[50]

            

{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
}}   