{{

Spin code by Clock Loop.   Host.
The code communicates with the wx module and a propeller that is connects to another prop via its wx module.

}}

CON 

  _CLKMODE  = XTAL1 + PLL16X                              ' The system clock spec
  _XINFREQ  = 5_000_000                                  ' Crystal

  Rx        = 31    'serial in from wx device
  Tx        = 30    'serial out to wx device
                  
OBJ

    ser:    "Parallax Serial Terminal.spin"

VAR 

    byte  Handle, ReplyStatus, HostListener
    long  Comm[100] 

Pub Main      'Cog #1
 
  cognew(Comms, @Comm)   'Cog #2 and #3
  
  waitcnt(80_000_000 + cnt) 'Wait for 1 s
                               
  Counter   'Start counter loop. Cog #1
                                                         
PUB Counter     'Cog #1
  Repeat    
    'Repeat 4
    waitcnt(80_000_000 + cnt)   'Wait for 1 s                                             
    Yaxis++
    Xaxis--

Pub Comms     'Cog #2 and #3

   
  dira[TX]~~          ' Set direction to output
  outa[TX]:= 0        ' Set TX low.                         
  waitcnt(5_000_000 + cnt)   'wait 1/16 second for command mode to start in the module.
  dira[TX]~           ' Set direction to input  
  
  ser.StartRxTx(RX, TX, 0, 115200)   'Cog #3  Parallax Serial Terminal does NOT work at receiving data 230400 for some reason.
  waitcnt(5_000_000 + cnt)   'wait 1/16 second for serial to start.                        
  
  ser.str(string(27))     'Set ansi command mode in putty.
  ser.str(string("[2J"))  'Clear putty telnet screen.
    
  ser.str(string(27))      'Set ansi command mode in putty.                 
  ser.str(string("[2;3f")) 'Set Position in putty.      
  ser.str(string("Prop Communication Started")) 'Tell putty command mode is on.                       
  ser.str(string(27))      'Set ansi command mode in putty.      
  ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0        
  Repeat 5  ' wait 5 seconds to help determine if prop reset.
    waitcnt(80_000_000 + cnt)   'wait 1 second 
  
  
  Reply[0] := 0  ' clear data
  Reply[1] := 0  ' clear data
  Reply[2] := 0  ' clear data
  Reply[3] := 0  ' clear data
  Reply[4] := 0  ' clear data
  Reply[5] := 0  ' clear data
  Reply[6] := 0  ' clear data
  Reply[7] := 0  ' clear data
  
  ser.rxflush                     
  waitcnt(5_000_000 + cnt)    'wait 1/16 second.
  ser.char(254)               'Begin marker
  waitcnt(5_000_000 + cnt)    'wait 1/16 second.
  ser.str(string("LISTEN:HTTP,/hostess"))  'Twinky 'Tell the module to listen to a specific path on Web Socket port 80.
  waitcnt(5_000_000 + cnt)    'wait 1/16 second.
  ser.char(13)                'End marker     
  waitcnt(5_000_000 + cnt)    'Wait for 1/16 s  Let buffer fill.
  Reply[0] := ser.rxcheck     ' should be 254
  Reply[1] := ser.rxcheck     ' should be =
  Reply[2] := ser.rxcheck     ' should be S
  Reply[3] := ser.rxcheck     ' should be ,
  Reply[4] := ser.rxcheck     ' should be 5, 6 this could change. Use this returned listener id with PATH or CLOSE commands. 
                              ' There are a maximum of four listeners available. 
                              ' Issuing additional LISTEN commands when all four listeners are already established,
                              '  will result in a response of b = E,4 E (NO_FREE_LISTENER) until a CLOSE command is used to free a listener.
  Reply[5] := ser.rxcheck     ' should be 13
  
  If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "S" And Reply[3] == "," And Reply[4] == "1" And Reply[5] == 13 
    HostListener := Reply[4]  
    
  Else
    ser.str(string(27))      'Set ansi command mode in putty.                 
    ser.str(string("[2;3f")) 'Set Position in putty.      
    ser.str(string("ERROR, wrong host listener returned, Power cycle the esp and prop.")) 'Tell putty error.                       
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0  
    Repeat
      waitcnt(80_000_000 + cnt) 'Wait for 1s forever.
        
  Repeat                'The main repeat loop.  Cog#2
    ser.str(string(27))     'Set ansi command mode in putty.
    ser.str(string("[2J"))  'Clear putty telnet screen. 
    
                                                                                        
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[5;1f")) 'Set Position in putty   
    ser.str(string("Xaxis- ")) 'Tell putty error.
    ser.dec(Xaxis)
    
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[6;1f")) 'Set Position in putty   
    ser.str(string("Yaxis- ")) 'Tell putty error.
    ser.dec(Yaxis)

    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[1:1f")) 'Set Position in putty     
    
    ser.str(string(27))      'Set ansi command mode in putty.                 
    ser.str(string("[2;3f")) 'Set Position in putty.      
    ser.str(string("Command Mode is On. ")) 'Tell putty command mode is on.                       
    ser.str(string(27))      'Set ansi command mode in putty.      
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[4;3f")) 'Set Position in putty
                                                           
    If ReplyStatus == 1     
      ser.str(string("Good reply."))   'If last reply was good, put it back up on putty which was cleared.
      ReplyStatus := 0                                 '                
    Else
      ser.str(string("  No reply."))    'If last reply was none, put it back up on putty which was cleared.   
                                              
    ser.str(string(27))      'Set ansi command mode in putty.                                               
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0                         
  
    Reply[0] := 0  ' clear data
    Reply[1] := 0  ' clear data
    Reply[2] := 0  ' clear data
    Reply[3] := 0  ' clear data
    Reply[4] := 0  ' clear data
    Reply[5] := 0  ' clear data
    Reply[6] := 0  ' clear data
    Reply[7] := 0  ' clear data
      
    Repeat 10
    
        Reply[0] := 0  ' clear data
        Reply[1] := 0  ' clear data
        Reply[2] := 0  ' clear data
        Reply[3] := 0  ' clear data
        Reply[4] := 0  ' clear data
        Reply[5] := 0  ' clear data
        Reply[6] := 0  ' clear data
        Reply[7] := 0  ' clear data
    
        ser.rxflush
        waitcnt(1_000_000 + cnt)    'wait 1/16 second.
        ser.char(254)  'Begin marker
        waitcnt(1_000_000 + cnt)    'wait 1/16 second.
        ser.str(string("POLL:"))   'Tell the module to listen to a ANY protocol/path.
        waitcnt(1_000_000 + cnt)    'wait 1/16 second.
        ser.char(13)    'End marker
        waitcnt(1_000_000 + cnt) 'Wait for 1/16 s  Let buffer fill.
        Reply[0] := ser.rxcheck   ' should be 254
        Reply[1] := ser.rxcheck   ' should be =
        Reply[2] := ser.rxcheck   ' should be P
        Reply[3] := ser.rxcheck   ' should be :
        Reply[4] := ser.rxcheck   ' should be 5 (this could change) The connection identifier to use for this request
        Reply[5] := ser.rxcheck   ' should be ,
        Reply[6] := ser.rxcheck   ' should be 1 or a 2. Use this returned listener id with PATH or CLOSE commands. 
                                  ' There are a maximum of four listeners available. 
                                  ' Issuing additional LISTEN commands when all four listeners are already established,
                                  '  will result in a response of b = E,4 E (NO_FREE_LISTENER) until a CLOSE command is used to free a listener.
        Reply[7] := ser.rxcheck   ' should be 13   
        
        'waitcnt(80_000_000 + cnt)    'wait 1 second.                                   
        
        If Reply[0] == 254 And Reply[1] == "=" And Reply[2] == "G" And Reply[6] == HostListener And Reply[7] == 13
            ReplyStatus := 1     'Set the reply to good so it can be shown in putty.
          
            Handle := Reply[4]  'Store connection identifier.
          
            Reply[0] := 0  ' clear data
            Reply[1] := 0  ' clear data
            Reply[2] := 0  ' clear data
            Reply[3] := 0  ' clear data
            Reply[4] := 0  ' clear data
            Reply[5] := 0  ' clear data
            Reply[6] := 0  ' clear data
            Reply[7] := 0  ' clear data                  
            
            ser.rxflush             
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.char(254)               'Begin marker
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.str(string("REPLY:"))   'Retrieve HTTP GET/POSTâ€™s name argument (in query or body) on connection handle.
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.char(Handle)            'An active connection handle; returned by POLL
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.str(string(","))        'Required for a reply
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.str(string("200"))      'The desired HTTP response code for the reply.                         
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.str(string(","))        'Required for a reply   
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.str(string("28"))        'Tell the module how many bytes? (or is this digits?) the reply is.
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.char(13)                'End marker                                        
            waitcnt(1_000_000 + cnt)    'wait 1/16 second.
            ser.char(13)                '\r new line
            ser.char(10)                '\n line feed        1
            ser.str(string("Xaxis>"))   'Send your data.
            ser.dec(Xaxis)
            ser.char(0)                'End marker 
            ser.char(13)                '\r new line
            ser.char(10)                '\n line feed        1
            ser.str(string("Yaxis>"))   'Send your data.
            ser.dec(Yaxis)
            ser.char(0)                'End marker 
            ser.char(13)                '\r new line
            ser.char(10)                '\n line feed        1
     

DAT
  Xaxis             long  1234
  Yaxis             long  5678
  CountHost         long  0
  'Byte[#]               '0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 18 20
  Reply             byte  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
}}   